import sys

sys.path.append(r'')
from benchmarks.benchmark import Benchmark
from benchmarks.CEC2013.cec2013.cec2013 import *


class CEC2013_FUNCTION(Benchmark):
    def __init__(self, i):
        self.function_id = i  # benchmark function id
        self.f = CEC2013(i)  #
        self.dimension = self.f.get_dimension()
        self.max_values = np.zeros(self.dimension)
        self.min_values = np.zeros(self.dimension)
        for k in range(self.dimension):
            self.max_values[k] = self.f.get_ubound(k)
            self.min_values[k] = self.f.get_lbound(k)
        super(CEC2013_FUNCTION, self).__init__(self.min_values, self.max_values, self.dimension)

    def get_optimum(self):
        return self.f.get_fitness_goptima()

    def eval(self, sol):
        return self.f.evaluate(sol)

    def evaluate(self, sol):
        return self.f.evaluate(sol)

    def get_rho(self):
        return self.f.get_rho()

    def get_fitness_goptima(self):
        return self.f.get_fitness_goptima()

    def get_no_goptima(self):
        return self.f.get_no_goptima()

    def get_maxfes(self):
        return self.f.get_maxfes()


if __name__ == '__main__':
    Func = CEC2013_FUNCTION(6)
    print(Func.global_optima_number())
    Func.plot(scale=0.05, save_path='../../tests/multi_modal_tests/output/FunctionFigureTest')
    # F15.get_optimum()
