import abc
from mpl_toolkits.mplot3d import Axes3D
from matplotlib import pyplot as plt
from numpy import inf, asarray, arange, meshgrid, vectorize
from matplotlib import cm


class Benchmark(metaclass=abc.ABCMeta):

    def __init__(self, min_values, max_values, dimension):
        self.min_values = min_values
        self.max_values = max_values
        self.dimension = dimension

    def get_optimum(self):
        return [0]*self.dimension, 0
        pass

    @staticmethod
    def eval(**kwargs):
        return inf
        pass

    def dfun(self, x, y, f): return f((x, y))

    def get_niche_radius(self):
        return inf
        pass

    def global_optima_number(self):
        return inf
        pass

    def get_maxfes(self):
        return inf
        pass

    def plot(self, scale, save_path):
        if not scale:
            scale = abs(self.max_values[0] / 100)
        fig = plt.figure()
        ax = fig.gca(projection='3d')
        ax.set_title('2D-Six-Hump Camel Back')
        func = self.eval
        X_range, Y_range = arange(self.min_values[0], self.max_values[0], scale), arange(self.min_values[1], self.max_values[1], scale)
        X, Y = meshgrid(X_range, Y_range)
        Z = vectorize(self.dfun)(X, Y, func)
        ax.plot_surface(X, Y, Z, rstride=1, cstride=1, alpha=0.8, cmap=cm.get_cmap('rainbow'))
        ax.contourf(X, Y, Z, zdir='z', offset=-5.5, cmap=plt.get_cmap('rainbow'))
        # cset = ax.contourf(X, Y, Z, zdir='z', offset=0, cmap=cm.coolwarm)
        # ax.set_xlabel('X')
        # ax.set_ylabel('Y')
        # ax.set_zlabel('Z')
        if save_path:
            #plt.savefig(save_path+'/{benchmark}.png'.format(benchmark=self.__class__.__name__), dpi=200)
            plt.savefig(save_path+'/Six-HumpCamelBack.png', dpi=200)
            plt.clf()
            plt.close()
        else:
            plt.show()
