import pandas as pd
import numpy as np
from Algorithms.algorithm import Algorithm


class localsearch:

    def __init__(self, position, delta, sampling_size, benchmark):
        self.position = position  # population position
        self.delta = delta  # gaussian distribution standard deviation
        self.sampling_size = sampling_size  # sample number
        self.benchmark = benchmark  # benchmark function

    def local_search(self):
        Seed = pd.DataFrame()  # save seed
        idmax = []  # save the fitness of seed
        for name, group in self.position.groupby('c'):
            event = group.loc[group['f'].idxmax()]
            idmax.append(group['f'].idxmax())
            Seed = Seed.append(event, ignore_index=True)
        FSE_min = Seed.loc[Seed['f'].idxmin(), 'f']
        FSE_max = Seed.loc[Seed['f'].idxmax(), 'f']
        flag = False
        if FSE_min <= 0:
            FSE_max = FSE_max + np.fabs(FSE_min) + 10 ** (-31)
            flag = True
        Prob = []  # save the probilities
        for index, row in Seed.iterrows():
            if flag:
                temp1 = row['f'] + np.fabs(FSE_min) + 10 ** (-31)
                temp2 = FSE_max + np.fabs(FSE_min) + 10 ** (-31)
                Prob.append(temp1 / temp2)
            else:
                Prob.append(row['f'] / FSE_max)
        temp = list()  # save the fitness of best sample
        Index = list()  # save the best sample
        Index_seed = list()  # save the index of individual replaced
        for index, row in Seed.iterrows():
            if np.random.random() <= Prob[index]:
                for i in range(self.sampling_size):
                    LS = np.random.normal(loc=row[0:self.benchmark.dimension], scale=self.delta)
                    LS = Algorithm().boundary_handle(LS)
                    if Algorithm().costfunction(LS) > Algorithm().costfunction(row[0:self.benchmark.dimension]):
                        Index.append(idmax[index])
                        Index_seed.append(index)
                        temp.append(Algorithm().costfunction(LS))
                        Seed.iloc[index, :self.benchmark.dimension] = LS
        for i in range(len(Index)):
            self.position.loc[Index[i], 'f'] = temp[i]
            self.position.iloc[Index[i], 2:] = Seed.iloc[Index_seed[i], :self.benchmark.dimension]
        return self.position
